package com.wosai.upay.demo;

import android.app.Activity;
import android.app.ProgressDialog;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.Spinner;
import android.widget.TextView;
import com.wosai.upay.bean.UpayOrder;
import com.wosai.upay.bean.UpayResult;
import com.wosai.upay.common.UpayCallBack;
import com.wosai.upay.common.UpayTask;
import com.wosai.upay.util.LogUtil;
import com.wosai.upay.util.StringUtil;
import com.wosai.upay.util.ToastUtil;
import com.wosai.upay.util.UIUtils;

import java.util.ArrayList;
import java.util.List;

public class InputActivity extends Activity implements View.OnClickListener {
    private TextView tvBack;
    private TextView tvTitle;
    private LinearLayout llActivateCode;
    private LinearLayout llVendorId;
    private LinearLayout llVendorKey;
    private LinearLayout llAppId;
    private LinearLayout llDeviceName;
    private LinearLayout llDeviceSn;
    private LinearLayout llClientSn;
    private LinearLayout llSn;
    private LinearLayout llRefundModel;
    private LinearLayout llTotalAmount;
    private LinearLayout llPayWay;
    private LinearLayout llPayCode;
    private LinearLayout llSubject;
    private LinearLayout llOperator;
    private LinearLayout llDescription;
    private LinearLayout llRefundRequestNo;
    private LinearLayout llRefundAmount;
    private EditText etActivateCode;
    private EditText etVendorId;
    private EditText etVendorKey;
    private EditText etAppId;
    private EditText etDeviceName;
    private EditText etDeviceSn;
    private EditText etClientSn;
    private EditText etSn;
    private EditText etTotalAmount;
    private EditText etPayCode;
    private EditText etSubject;
    private EditText etOperator;
    private EditText etDescription;
    private EditText etRefundRequestNo;
    private EditText etRefundAmount;
    private RadioGroup radioGroup;
    private RadioButton rbClientSn, rbSn;
    private Spinner spinnerPayWay;
    private List<String> lstType = new ArrayList<String>();
    private ArrayAdapter<String> typeAdapter;
    private Button btnOK;
    private LinearLayout llResult;
    private TextView tvResult;
    private Button btnBack;
    private ProgressDialog pd;
    private String payWay;
    private UpayOrder order;
    private UpayOrder.PayModel payModel;
    /**
     * ATTENTION: This was auto-generated to implement the App Indexing API.
     * See https://g.co/AppIndexing/AndroidStudio for more information.
     */

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(UIUtils.isPad(this) ? R.layout.activity_input_pad : R.layout.activity_input_phone);
        initView();
        initData();
        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
//        client = new GoogleApiClient.Builder(this).addApi(AppIndex.API).build();
    }

    private void initView() {
        tvTitle = (TextView) findViewById(R.id.tv_title);
        tvBack = (TextView) findViewById(R.id.tv_back);
        tvBack.setOnClickListener(this);
        llActivateCode = (LinearLayout) findViewById(R.id.llActivateCode);
        llVendorId = (LinearLayout) findViewById(R.id.llVendorId);
        llVendorKey = (LinearLayout) findViewById(R.id.llVendorKey);
        llAppId = (LinearLayout) findViewById(R.id.llAppId);
        llDeviceName = (LinearLayout) findViewById(R.id.llDeviceName);
        llDeviceSn = (LinearLayout) findViewById(R.id.llDeviceSn);
        llClientSn = (LinearLayout) findViewById(R.id.llClientSn);
        llSn = (LinearLayout) findViewById(R.id.llSn);
        llRefundModel = (LinearLayout) findViewById(R.id.llRefundModel);
        llTotalAmount = (LinearLayout) findViewById(R.id.llTotalAmount);
        llPayWay = (LinearLayout) findViewById(R.id.llPayWay);
        llPayCode = (LinearLayout) findViewById(R.id.llPayCode);
        llSubject = (LinearLayout) findViewById(R.id.llSubject);
        llOperator = (LinearLayout) findViewById(R.id.llOperator);
        llDescription = (LinearLayout) findViewById(R.id.llDescription);
        llRefundRequestNo = (LinearLayout) findViewById(R.id.llRefundRequestNo);
        llRefundAmount = (LinearLayout) findViewById(R.id.llRefundAmount);
        etActivateCode = (EditText) findViewById(R.id.etActivateCode);
        etVendorId = (EditText) findViewById(R.id.etVendorId);
        etVendorKey = (EditText) findViewById(R.id.etVendorKey);
        etAppId = (EditText) findViewById(R.id.etAppId);
        etDeviceName = (EditText) findViewById(R.id.etDeviceName);
        etDeviceSn = (EditText) findViewById(R.id.etDeviceSn);
        etClientSn = (EditText) findViewById(R.id.etClientSn);
        etSn = (EditText) findViewById(R.id.etSn);
        etTotalAmount = (EditText) findViewById(R.id.etTotalAmount);
        etPayCode = (EditText) findViewById(R.id.etPayCode);
        etSubject = (EditText) findViewById(R.id.etSubject);
        etOperator = (EditText) findViewById(R.id.etOperator);
        etDescription = (EditText) findViewById(R.id.etDescription);
        etRefundRequestNo = (EditText) findViewById(R.id.etRefundRequestNo);
        etRefundAmount = (EditText) findViewById(R.id.etRefundAmount);
        radioGroup = (RadioGroup) findViewById(R.id.radio_group);
        rbClientSn = (RadioButton) findViewById(R.id.rbClientSn);
        rbSn = (RadioButton) findViewById(R.id.rbSn);
        spinnerPayWay = (Spinner) findViewById(R.id.spinnerPayWay);
        btnOK = (Button) findViewById(R.id.btnOK);
        btnOK.setOnClickListener(this);
        llResult = (LinearLayout) findViewById(R.id.llResult);
        tvResult = (TextView) findViewById(R.id.tvResult);
        btnBack = (Button) findViewById(R.id.btnBack);
        btnBack.setOnClickListener(this);

        pd = new ProgressDialog(this);
//        pd.setIcon(android.R.drawable.ic_dialog_email);
        pd.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        pd.setMax(100);
        pd.setMessage("正在加载中...");
        pd.setCanceledOnTouchOutside(false);
    }

    private void initData() {
        order = (UpayOrder) getIntent().getSerializableExtra("UpayOrder");
        payModel = order.getPayModel();

        switch (order.getExecuteType()) {
            case ACTIVATE:
                tvTitle.setText(R.string.activate);
                if (payModel == UpayOrder.PayModel.NO_UI) {
                    llActivateCode.setVisibility(View.VISIBLE);
                    llDeviceName.setVisibility(View.VISIBLE);
                    llDeviceSn.setVisibility(View.VISIBLE);
                }
                llVendorId.setVisibility(View.VISIBLE);
                llVendorKey.setVisibility(View.VISIBLE);
                llAppId.setVisibility(View.VISIBLE);
                break;
            case PAY:
                tvTitle.setText(R.string.pay);
                if (payModel == UpayOrder.PayModel.NO_UI) {
                    llPayCode.setVisibility(View.VISIBLE);
                }
                llClientSn.setVisibility(View.VISIBLE);
                llTotalAmount.setVisibility(View.VISIBLE);
                llPayWay.setVisibility(View.VISIBLE);
                lstType.add("无");
                llSubject.setVisibility(View.VISIBLE);
                llOperator.setVisibility(View.VISIBLE);
                llDescription.setVisibility(View.VISIBLE);
                break;
            case REFUND:
                tvTitle.setText(R.string.refund);
                if (payModel == UpayOrder.PayModel.UI) {
                    llRefundModel.setVisibility(View.VISIBLE);
                    rbClientSn.setChecked(true);
                }
                llClientSn.setVisibility(View.VISIBLE);
                llSn.setVisibility(View.VISIBLE);
                llOperator.setVisibility(View.VISIBLE);
                llRefundRequestNo.setVisibility(View.VISIBLE);
                llRefundAmount.setVisibility(View.VISIBLE);
                break;
            case PRECREATE:
                tvTitle.setText(R.string.pay);
                llClientSn.setVisibility(View.VISIBLE);
                llTotalAmount.setVisibility(View.VISIBLE);
                llPayWay.setVisibility(View.VISIBLE);
                llSubject.setVisibility(View.VISIBLE);
                llOperator.setVisibility(View.VISIBLE);
                llDescription.setVisibility(View.VISIBLE);
                break;
            case REVOKE:
                tvTitle.setText(R.string.revoke);
                if (payModel == UpayOrder.PayModel.UI) {
                    llRefundModel.setVisibility(View.VISIBLE);
                    rbClientSn.setChecked(true);
                }
                llClientSn.setVisibility(View.VISIBLE);
                llSn.setVisibility(View.VISIBLE);
                break;
            case QUERY:
                tvTitle.setText(R.string.query);
                llClientSn.setVisibility(View.VISIBLE);
                llSn.setVisibility(View.VISIBLE);
                break;
        }

        lstType.add("支付宝");
        lstType.add("微信");
        lstType.add("百付宝");
        lstType.add("京东");
        lstType.add("qq钱包");
        typeAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, lstType);
        typeAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinnerPayWay.setAdapter(typeAdapter);
        spinnerPayWay.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            public void onItemSelected(AdapterView<?> parent, View view,
                                       int position, long id) {
                if (typeAdapter.getItem(position).equals("支付宝")) {
                    payWay = "1";
                } else if (typeAdapter.getItem(position).equals("微信")) {
                    payWay = "3";
                } else if (typeAdapter.getItem(position).equals("百付宝")) {
                    payWay = "4";
                } else if (typeAdapter.getItem(position).equals("京东")) {
                    payWay = "5";
                } else if (typeAdapter.getItem(position).equals("qq钱包")) {
                    payWay = "6";
                } else {
                    payWay = null;
                }
            }

            public void onNothingSelected(AdapterView<?> parent) {
            }
        });

        etActivateCode.setText("5764937738");
        etVendorId.setText("1");
        etVendorKey.setText("5bb7edebc0dd3698ad239f55f7ccc9c2");
        etAppId.setText(getPackageName());
        etDeviceName.setText("终端名" + (int) (Math.random() * 10000000));
        etDeviceSn.setText("终端号" + (int) (Math.random() * 10000000));
        etClientSn.setText("client" + (int) (Math.random() * 10000000));
        etSn.setText("7894259244086017");
        etPayCode.setText("285362899388441557");
        etSubject.setText("Android SDK");
        etOperator.setText("操作员007");
        etRefundRequestNo.setText((int) (Math.random() * 10000000) + "");

        etActivateCode.setSelection(etActivateCode.getText().toString().trim().length());
        etClientSn.setSelection(etClientSn.getText().toString().trim().length());
        etSn.setSelection(etSn.getText().toString().trim().length());
        etPayCode.setSelection(etPayCode.getText().toString().trim().length());
        etSubject.setSelection(etSubject.getText().toString().trim().length());
        etOperator.setSelection(etOperator.getText().toString().trim().length());
        etRefundRequestNo.setSelection(etRefundRequestNo.getText().toString().trim().length());
    }

    @Override
    public void onClick(View v) {
        String activateCode = etActivateCode.getText().toString().trim();
        String vendorId = etVendorId.getText().toString().trim();
        String vendorKey = etVendorKey.getText().toString().trim();
        String appId = etAppId.getText().toString().trim();
        String deviceName = etDeviceName.getText().toString().trim();
        String deviceSn = etDeviceSn.getText().toString().trim();
        String clientSn = etClientSn.getText().toString().trim();
        String sn = etSn.getText().toString().trim();
        String totalAmount = etTotalAmount.getText().toString().trim();
        String payCode = etPayCode.getText().toString().trim();
        String subject = etSubject.getText().toString().trim();
        String operator = etOperator.getText().toString().trim();
        String description = etDescription.getText().toString().trim();
        String refundRequestNo = etRefundRequestNo.getText().toString().trim();
        String refundAmount = etRefundAmount.getText().toString().trim();
        UpayTask task = UpayTask.getInstance();
        UIUtils.hideKeyboard(this, getWindow().peekDecorView());
        switch (v.getId()) {
            case R.id.tv_back:
            case R.id.btnBack:
                finish();
                break;
            case R.id.btnOK:
                switch (order.getExecuteType()) {
                    case ACTIVATE:
                        if (StringUtil.isEmpty(vendorId)) {
                            ToastUtil.toast(this, "服务商Id不能为空");
                            return;
                        }
                        if (StringUtil.isEmpty(vendorKey)) {
                            ToastUtil.toast(this, "服务商key不能为空");
                            return;
                        }
                        if (payModel == UpayOrder.PayModel.NO_UI) {
                            if (StringUtil.isEmpty(activateCode)) {
                                ToastUtil.toast(this, "激活码不能为空");
                                return;
                            }
                            pd.show();
                        }
                        if (StringUtil.isEmpty(appId)) {
                            task.activate(activateCode, vendorId, vendorKey, order.getPayModel(), new UpayCallBack() {
                                @Override
                                public void onExecuteResult(UpayResult result) {
                                    dealResult(result);
                                }
                            });
                        } else {
                            task.activate(activateCode, vendorId, vendorKey, appId, deviceSn, deviceName, order.getPayModel(), new UpayCallBack() {
                                @Override
                                public void onExecuteResult(UpayResult result) {
                                    dealResult(result);
                                }
                            });
                        }

                        break;
                    case PAY:
                        if (StringUtil.isEmpty(clientSn)) {
                            ToastUtil.toast(this, "商户订单号不能为空");
                            return;
                        }
                        if (StringUtil.isEmpty(totalAmount)) {
                            ToastUtil.toast(this, "交易金额不能为空");
                            return;
                        }
                        if (payModel == UpayOrder.PayModel.NO_UI && StringUtil.isEmpty(payCode)) {
                            ToastUtil.toast(this, "支付码不能为空");
                            return;
                        }
                        if (StringUtil.isEmpty(subject)) {
                            ToastUtil.toast(this, "交易简介不能为空");
                            return;
                        }
                        if (StringUtil.isEmpty(operator)) {
                            ToastUtil.toast(this, "门店操作员不能为空");
                            return;
                        }
                        order.setClient_sn(clientSn);
                        order.setTotal_amount(UIUtils.stringToCent(totalAmount) + "");
                        order.setPayway(payWay);
                        order.setDynamic_id(payCode);
                        order.setSubject(subject);
                        order.setOperator(operator);
                        order.setDescription(description);
                        order.setReflect("测试反射参数");
                        if (payModel == UpayOrder.PayModel.NO_UI) {
                            pd.show();
                        }
                        task.pay(order, new UpayCallBack() {
                            @Override
                            public void onExecuteResult(UpayResult result) {
                                pd.cancel();
                                dealResult(result);
                            }
                        });
                        break;
                    case REFUND:
//                        if(StringUtil.isEmpty(clientSn)){
//                            ToastUtil.toast(this, "商户订单号不能为空");
//                            return;
//                        }
                        if (StringUtil.isEmpty(refundRequestNo)) {
                            ToastUtil.toast(this, "退款序列号不能为空");
                            return;
                        }
                        if (StringUtil.isEmpty(operator)) {
                            ToastUtil.toast(this, "门店操作员不能为空");
                            return;
                        }

                        if (payModel == UpayOrder.PayModel.NO_UI) {
                            if (StringUtil.isEmpty(clientSn) && StringUtil.isEmpty(sn)) {
                                ToastUtil.toast(this, "商户订单号和收钱吧订单号不能同时为空");
                                return;
                            }
                            if (StringUtil.isEmpty(refundAmount)) {
                                ToastUtil.toast(this, "退款金额不能为空");
                                return;
                            }
                            order.setSn(sn);
                            order.setClient_sn(clientSn);
                            order.setRefund_amount(UIUtils.stringToCent(refundAmount) + "");
                            pd.show();
                        } else {
                            if (radioGroup.getCheckedRadioButtonId() == R.id.rbClientSn) {
                                order.setRefundModel(UpayOrder.RefundModel.CLIENT_SN);
                                order.setClient_sn(clientSn);
                            } else {
                                order.setRefundModel(UpayOrder.RefundModel.SN);
                                order.setSn(sn);
                            }
                            if (StringUtil.isNotEmpty(refundAmount)) {
                                order.setRefund_amount(UIUtils.stringToCent(refundAmount) + "");
                            } else {
                                order.setRefund_amount(null);
                            }
                        }
                        order.setRefund_request_no(refundRequestNo);
                        order.setOperator(operator);
                        order.setReflect("测试反射参数");
                        task.refund(order, new UpayCallBack() {
                            @Override
                            public void onExecuteResult(UpayResult result) {
                                dealResult(result);
                            }
                        });
                        break;
                    case QUERY:
                        if (StringUtil.isEmpty(clientSn) && StringUtil.isEmpty(sn)) {
                            ToastUtil.toast(this, "商户订单号和收钱吧订单号不能同时为空");
                            return;
                        }
                        order.setSn(sn);
                        order.setClient_sn(clientSn);
                        if (payModel == UpayOrder.PayModel.NO_UI) {
                            pd.show();
                        }
                        task.query(order, new UpayCallBack() {
                            @Override
                            public void onExecuteResult(UpayResult result) {
                                dealResult(result);
                            }
                        });
                        break;
                    case REVOKE:
                        if (payModel == UpayOrder.PayModel.NO_UI) {
                            if (StringUtil.isEmpty(clientSn) && StringUtil.isEmpty(sn)) {
                                ToastUtil.toast(this, "商户订单号和收钱吧订单号不能同时为空");
                                return;
                            }
                            order.setSn(sn);
                            order.setClient_sn(clientSn);
                            pd.show();
                        } else {
                            if (radioGroup.getCheckedRadioButtonId() == R.id.rbClientSn) {
                                order.setRevokeModel(UpayOrder.RevokeModel.CLIENT_SN);
                                order.setClient_sn(clientSn);
                            } else {
                                order.setRevokeModel(UpayOrder.RevokeModel.SN);
                                order.setSn(sn);
                            }
                        }
                        order.setReflect("测试反射参数");
                        task.revoke(order, new UpayCallBack() {
                            @Override
                            public void onExecuteResult(UpayResult result) {
                                dealResult(result);
                            }
                        });
                        break;
                    case PRECREATE:
                        if (StringUtil.isEmpty(clientSn)) {
                            ToastUtil.toast(this, "商户订单号不能为空");
                            return;
                        }
                        if (StringUtil.isEmpty(totalAmount)) {
                            ToastUtil.toast(this, "交易金额不能为空");
                            return;
                        }
                        if (payModel == null) {
                            ToastUtil.toast(this, "支付方式不能为空");
                            return;
                        }
                        if (StringUtil.isEmpty(subject)) {
                            ToastUtil.toast(this, "交易简介不能为空");
                            return;
                        }
                        if (StringUtil.isEmpty(operator)) {
                            ToastUtil.toast(this, "门店操作员不能为空");
                            return;
                        }
                        order.setClient_sn(clientSn);
                        order.setTotal_amount(UIUtils.stringToCent(totalAmount) + "");
                        order.setPayway(payWay);
                        order.setSubject(subject);
                        order.setOperator(operator);
                        order.setDescription(description);
                        order.setReflect("测试反射参数");
                        if (payModel == UpayOrder.PayModel.NO_UI) {
                            pd.show();
                        }
                        task.preCreate(order, new UpayCallBack() {
                            @Override
                            public void onExecuteResult(UpayResult result) {
                                dealResult(result);
                            }
                        });
                        break;
                }
                break;
        }
    }

    private void dealResult(UpayResult result) {
        pd.cancel();
        LogUtil.d(result.toString());
        tvResult.setText(result.toString());
        llResult.setVisibility(View.VISIBLE);
//        ToastUtil.toast(InputActivity.this, result.getError_message(), Toast.LENGTH_LONG).show();
    }


}
