package com.wosai.upay.demo;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.CheckBox;
import android.widget.CompoundButton;

import com.wosai.upay.bean.UpayOrder;
import com.wosai.upay.common.DebugConfig;
import com.wosai.upay.common.UpayTask;
import com.wosai.upay.http.Env;
import com.wosai.upay.util.ToastUtil;

public class MainActivity extends Activity implements View.OnClickListener{

    private UpayTask task = UpayTask.getInstance();
    private CheckBox cbSound, cbDev, cbPro;
    private boolean isOpenSound;
    private Env.UrlType serverUrl;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        findViewById(R.id.isActivated).setOnClickListener(this);
        findViewById(R.id.activate).setOnClickListener(this);
        findViewById(R.id.signIn).setOnClickListener(this);
        findViewById(R.id.pay).setOnClickListener(this);
        findViewById(R.id.refund).setOnClickListener(this);
        findViewById(R.id.query).setOnClickListener(this);
        findViewById(R.id.revoke).setOnClickListener(this);
        findViewById(R.id.preCreate).setOnClickListener(this);
        findViewById(R.id.cancel).setOnClickListener(this);
        findViewById(R.id.activateUI).setOnClickListener(this);
        findViewById(R.id.payUI).setOnClickListener(this);
        findViewById(R.id.refundUI).setOnClickListener(this);
        findViewById(R.id.revokeUI).setOnClickListener(this);
        findViewById(R.id.preCreateUI).setOnClickListener(this);
        cbSound = (CheckBox) findViewById(R.id.cbSound);
        cbDev = (CheckBox) findViewById(R.id.cbDev);
        cbPro = (CheckBox) findViewById(R.id.cbPro);
        cbPro.setChecked(true);
        serverUrl = Env.UrlType.PRO;
        cbSound.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                isOpenSound = isChecked;
                task.initUpay(MainActivity.this, isOpenSound, serverUrl);
            }
        });
        cbDev.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if(isChecked){
                    cbPro.setChecked(false);
                    serverUrl = Env.UrlType.DEV;
                    task.initUpay(MainActivity.this, isOpenSound, serverUrl);
                }
            }
        });
        cbPro.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if(isChecked){
                    cbDev.setChecked(false);
                    serverUrl = Env.UrlType.PRO;
                    task.initUpay(MainActivity.this, isOpenSound, serverUrl);
                }
            }
        });

        DebugConfig.setDebug(true);//默认为非调试模式，如果需要调试，请设置为true，打印和保存相关日志
        task.initUpay(this, false, serverUrl);
    }

    @Override
    public void onClick(View v) {
        UpayOrder order = new UpayOrder();
        Intent intent = new Intent(this, InputActivity.class);
        switch (v.getId()){
            case R.id.isActivated:
                if (task.isActivated()){
                    ToastUtil.toast(this, "终端已激活");
                }else{
                    ToastUtil.toast(this, "终端未激活");
                }
                return;
            case R.id.activate:
                order.setPayModel(UpayOrder.PayModel.NO_UI);
                order.setExecuteType(UpayOrder.ExecuteType.ACTIVATE);
                break;
            case R.id.signIn:
                break;
            case R.id.pay:
                order.setPayModel(UpayOrder.PayModel.NO_UI);
                order.setExecuteType(UpayOrder.ExecuteType.PAY);
                break;
            case R.id.refund:
                order.setPayModel(UpayOrder.PayModel.NO_UI);
                order.setExecuteType(UpayOrder.ExecuteType.REFUND);
                break;
            case R.id.query:
                order.setPayModel(UpayOrder.PayModel.NO_UI);
                order.setExecuteType(UpayOrder.ExecuteType.QUERY);
                break;
            case R.id.revoke:
                order.setPayModel(UpayOrder.PayModel.NO_UI);
                order.setExecuteType(UpayOrder.ExecuteType.REVOKE);
                break;
            case R.id.preCreate:
                order.setPayModel(UpayOrder.PayModel.NO_UI);
                order.setExecuteType(UpayOrder.ExecuteType.PRECREATE);
                break;
            case R.id.cancel:
                order.setSn("7894259244065911");
                order.setClient_sn("1000357");
                order.setPayModel(UpayOrder.PayModel.NO_UI);
//                task.cancel(order, new UpayCallBack() {
//                    @Override
//                    public void onExecuteResult(UpayResult result) {
//                        LogUtil.d(result.toString());
//                    }
//                });
                break;
            case R.id.activateUI:
                order.setPayModel(UpayOrder.PayModel.UI);
                order.setExecuteType(UpayOrder.ExecuteType.ACTIVATE);
                break;
            case R.id.payUI:
                order.setPayModel(UpayOrder.PayModel.UI);
                order.setExecuteType(UpayOrder.ExecuteType.PAY);
                break;
            case R.id.refundUI:
                order.setPayModel(UpayOrder.PayModel.UI);
                order.setExecuteType(UpayOrder.ExecuteType.REFUND);
                break;
            case R.id.revokeUI:
                order.setPayModel(UpayOrder.PayModel.UI);
                order.setExecuteType(UpayOrder.ExecuteType.REVOKE);
                break;
            case R.id.preCreateUI:
                order.setPayModel(UpayOrder.PayModel.UI);
                order.setExecuteType(UpayOrder.ExecuteType.PRECREATE);
                break;
        }
        intent.putExtra("UpayOrder", order);
        startActivity(intent);
    }
}
